// Java & Bzier
// (C) 2002 Emmanuel Turquin
//
// StatusBar.java
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import javax.swing.*;
import java.awt.event.*;

public class StatusBar extends JLabel{
    public final static int DISPLAY_TIME = 2000;
    boolean available = true;
    Timer timer;
	

    public StatusBar(){
	timer = new Timer(DISPLAY_TIME, new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    clear();
		}    
	    });
    }

    public StatusBar(String msg){
	super(msg);
	timer = new Timer(DISPLAY_TIME, new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    clear();
		}    
	    });
    }

    public void displayMsg(final String msg){
	setText(msg);
	timer.stop();
	timer.start();
	available = false;
    }

    public void displayMsgBG(final String msg){
	if (!available)
	    return;
	setText(msg);
	timer.stop();
	timer.start();
    }

    void clear(){
	setText(" ");
	timer.stop();
	available = true;
    }

    public void setText(String s){
	super.setText(" " + s);
    }
}
