// Java & Bzier
// (C) 2002 Emmanuel Turquin
//
// Curve.java
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package jnb;

import java.util.*;
import java.awt.*;

public abstract class Curve{

    public static final float		THICKNESS = 2.0f;

    java.util.List			list;
    PointList				plist;
    boolean				visible = true;
    int					nbMin = 2;
    Color				color = Color.black;

    //constructor
    public Curve(){
	list = new LinkedList();
    }

    public Curve(PointList pl){
	list = new LinkedList();
	setPointList(pl);
    }

    //setPointList
    public void setPointList(PointList pl){
	plist = pl;
    }

    //getPointList
    public PointList getPointList(){
	return plist;
    }


    //isVisible
    public boolean isVisible(){
	return visible;
    }

    //setVisible
    public void setVisible(boolean b){
	visible = b;
    }

    //getColor
    public Color getColor(){
	return color;
    }

    //setColor
    public void setColor(Color c){
	color = c;
    }

}
