// Java & Bzier
// (C) 2002 Emmanuel Turquin
//
// Curve2D.java
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package jnb;

import java.util.*;
import java.awt.*;
import java.awt.geom.*;

public abstract class Curve2D extends Curve{

    static int subdiv = 10;

    //constructor
    public Curve2D(){
	super();
    }

    public Curve2D(Point2DList pl){
	super(pl);
    }

    //getSubdiv
    static public int getSubdiv() {
	return subdiv;
    }

    //setSubdiv
    static public void setSubdiv(int sd) {
	subdiv = Math.max(sd, 1);
    }

    //draw
    public final void draw(Graphics2D g, Point2DList current, Point2DList active){
	if (plist == null)
	    return;

	Point2DList pl = (Point2DList)plist;

	if (!visible || pl.size() <= (nbMin - 1))
	  return;
	g.setPaint(color);
	g.setStroke(new BasicStroke(THICKNESS));

	if (pl == current || pl == active) {
	    list.clear();
	    computeSegments();
	}

	ListIterator li = list.listIterator();
	java.awt.geom.Point2D.Double p1, p2;
	Line2D.Double line = new Line2D.Double();

	p2 = (java.awt.geom.Point2D.Double)li.next();

	int t = 0;

	while (li.hasNext())
	    {
		p1 = p2;
		p2 = (java.awt.geom.Point2D.Double)li.next();
		if (p1 != null && p2 != null){
		    line.setLine(p1, p2);
		    g.draw(line);
		}
	    }
    }

    //computeSegments
    abstract void computeSegments();

}
