// Java & Bzier
// (C) 2002 Emmanuel Turquin
//
// Curve2DEllipse.java
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package jnb;

import java.util.*;
import java.awt.*;

public class Curve2DEllipse extends Curve2D{

    protected static final double      	ANGLE = 2 * java.lang.Math.PI;

    double[]	tmp;
    boolean	circle;

     //constructor
    public Curve2DEllipse(boolean c){
	super();
	circle = c;
    }

    public Curve2DEllipse(boolean c, Point2DList pl){
	super(pl);
	circle = c;
    }

    //computeSegments
    void computeSegments(){
	Point2DList pl = (Point2DList)plist;
	int sd = 5 * subdiv;

	tmp = new double[sd + 1];
	for (int i = 0; i <= sd; i++)
	    tmp[i] = (double)(i * ANGLE) / sd;

	java.awt.geom.Point2D.Double p;
	double a, b, x0, y0, x1, y1;

	x0 = ((Point2D)pl.get(0)).getX();
	y0 = ((Point2D)pl.get(0)).getY();
	x1 = ((Point2D)pl.get(1)).getX();
	y1 = ((Point2D)pl.get(1)).getY();
	if (circle) {
	    a = b = java.lang.Math.pow(java.lang.Math.pow(x1 - x0, 2) + java.lang.Math.pow(y1 - y0, 2), 0.5);
	} else {
	    a = x1 - x0;
	    b = y1 - y0;
	}

	for (int t = 0; t <= sd; t++) {
	    p = new java.awt.geom.Point2D.Double(x0 + a * java.lang.Math.cos(tmp[t]), y0 + b * java.lang.Math.sin(tmp[t]));		
	    list.add(p);
	}
    }
}
