// Java & Bzier
// (C) 2002 Emmanuel Turquin
//
// Curve2DHermite.java
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package jnb;

import java.util.*;
import java.awt.*;

public class Curve2DHermite extends Curve2D{

    double[]	tmp;
    int		size;
    int		n;

     //constructor
    public Curve2DHermite(){
	super();
	n = 3;
    }

    public Curve2DHermite(Point2DList pl){
	super(pl);
	n = 3;
    }

    //computeSegments
    void computeSegments(){
	Point2DList pl = (Point2DList)plist;
	
	size = subdiv * n;
	tmp = new double[size + 1];
	for (int i = 0; i <= size; i++)
	    tmp[i] = (double)i / size;
	
	java.awt.geom.Point2D.Double p;
	double h03, h13, k03, k13;

	for (int i = 0; i < pl.size() - 1; i += n) {
	    int d = Math.min(n, pl.size() - i - 1);
	    
	    for (int t = 0; t <= size; t++) {
		h03 = HTerm03(t);
		h13 = HTerm13(t);
		k03 = KTerm03(t);
		k13 = KTerm13(t);
		p = new java.awt.geom.Point2D.Double(((Point2D)pl.get(i)).getX() * h03 +
						     ((Point2D)pl.get(i + d)).getX() * h13 +
						     (((Point2D)pl.get(i + 1)).getX() - ((Point2D)pl.get(i)).getX()) * k03 +
						     (((Point2D)pl.get(i + d - 1)).getX() - ((Point2D)pl.get(i + d)).getX()) * k13,
						     ((Point2D)pl.get(i)).getY() * h03 +
						     ((Point2D)pl.get(i + d)).getY() * h13 +
						     (((Point2D)pl.get(i + 1)).getY() - ((Point2D)pl.get(i)).getY()) * k03 +
						     (((Point2D)pl.get(i + d - 1)).getY() - ((Point2D)pl.get(i + d)).getY()) * k13);
		list.add(p);
	    }
	}
    }

    double HTerm03(int t){
	return 2 * Math.pow(tmp[t], 3) - 3 * Math.pow(tmp[t], 2) + 1;
    }

    double HTerm13(int t){
	return -2 * Math.pow(tmp[t], 3) + 3 *Math.pow(tmp[t], 2);
    }
    double KTerm03(int t){
	return Math.pow(tmp[t], 3) - 2 * Math.pow(tmp[t], 2) + tmp[t];
    }
    double KTerm13(int t){
	return -Math.pow(tmp[t], 3) + Math.pow(tmp[t], 2);
    }
}
