// Java & Bzier
// (C) 2002 Emmanuel Turquin
//
// Curve2DLagrange.java
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package jnb;

import java.util.*;
import java.awt.*;

public class Curve2DLagrange extends Curve2D{

    double[]	tmp;
    int		size;
    int		n;

     //constructor
    public Curve2DLagrange(){
	super();
    }

    public Curve2DLagrange(Point2DList pl){
	super(pl);
    }

    //computeSegments
    void computeSegments(){
	Point2DList pl = (Point2DList)plist;

	n = pl.size() - 1;

	size = subdiv * n;
	tmp = new double[size + 1];
	for (int i = 0; i <= size; i++)
	    tmp[i] = (double)i / size;

	java.awt.geom.Point2D.Double p;
	double x, y, lt;

	for (int t = 0; t <= size; t++) {
	    x = 0;
	    y = 0;
	    for (int i = 0; i <= n; i++) {
		lt = LagrangeTerm(i, t);
		x += ((Point2D)pl.get(i)).getX() * lt;
		y += ((Point2D)pl.get(i)).getY() * lt;
	    }
	    p = new java.awt.geom.Point2D.Double(x, y);
	    list.add(p);
	}
    }

    double LagrangeTerm(int i, int t){
	double d = 1;

	for (int j = 0; j <= n; j++){
	    if (j != i)
		d *= (tmp[t] - tmp[subdiv * j]) / (tmp[subdiv * i] - tmp[subdiv * j]);
	}
	return d;
    }
    
}
