// Java & Bzier
// (C) 2002 Emmanuel Turquin
//
// CurveList.java
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package jnb;

import java.util.*;
import java.awt.*;

public abstract class CurveList{

    java.util.List	       		list;

    //constructor
    public CurveList(){
	list = new LinkedList();
    }

    //listIterator
    public ListIterator listIterator(){
	return list.listIterator();
    }

    //add
    public void add(Curve c){
	list.add(c);
    }

    public void add(int i, Curve c){
	list.add(i, c);
    }

    //remove
    public int remove(Curve c){
	list.remove(c);
	if (size() == 0)
	    return 1;
	return 0;
    }

    public int remove(int i){
	list.remove(i);
	if (size() == 0)
	    return 1;
	return 0;
    }

    public int remove(PointList pl){

	for (ListIterator li = list.listIterator(); li.hasNext(); )
	    {
		Curve c = (Curve)li.next();
		if (pl == (PointList)c.getPointList())
		    li.remove();
	    }
	if (size() == 0)
	    return 1;
	return 0;
    }

    //clear
    public void clear()
    {
	list.clear();
    }

    //get
    public Curve get(int i){
	return (Curve)list.get(i);
    }

    //size
    public int size(){
	return list.size();
    }

}
